// -------------------------------------------------------------------------------------
//
// FiFaTest.CPP                                                   Ulrich Mller 13.08.04
//                                                                PCS1700       VC++ 6.0
// Testrahmen fr die Klasse CFishFace ... in FishFa30.H/CPP
//
// -------------------------------------------------------------------------------------

#include <windows.h>
#include <iostream.h>
#include <string>
#include "FishFa30.h"

CFishFace ft(true, false, 0);

void BlinkingLoop() {
	do {
		ft.SetMotor(ftiM1, ftiOn);
		ft.Pause(555);
		ft.SetMotor(ftiM1, ftiOff);
		ft.Pause(444);
	} while(!ft.Finish());
}

void AlternateBlinking1() {
	do {
		ft.SetMotor(ftiM2, ftiOff);
		ft.SetMotor(ftiM1, ftiOn);
		ft.Pause(444);
		ft.SetMotor(ftiM1, ftiOff);
		ft.SetMotor(ftiM2, ftiOn);
		ft.Pause(444);
	} while(!ft.Finish());
}

void AlternateBlinking2() {
	do {
		ft.SetMotors(0x1);
		ft.Pause(333);
		ft.SetMotors(0x4);
		ft.Pause(333);
	} while(!ft.Finish());
}

void TestingAnInput() {
	do {
		if(ft.GetInput(ftiE1)) cout << "--- ON ---" << endl;
		else cout << "--- OFF ---" << endl;
		ft.Pause(555);
	} while(!ft.Finish(ftiE5));
}

void WaitForInput() {
	cout << "For start press E1" << endl;
	ft.WaitForInput(ftiE1);
	cout << "--- STARTED ---" << endl;
}

void DisplayAllInputs1() {
	do { 
		for(int i = 0x80, E = ft.Inputs(); i > 0; i >>= 1) {
			cout << ((E & i) > 0) ? "1" : "0";
		}
		cout << endl;
		ft.Pause(1234);
	} while(!ft.Finish());
}

void DisplayAllInputs2() {
	std::string EWerte;
	do { 
		EWerte = "";
		for(int i = 0x80, E = ft.Inputs(); i > 0; i >>= 1) {
			EWerte += ((E & i) > 0) ? "1" : "0";
		}
		cout << EWerte.data() << endl;
		ft.Pause(1234);
	} while(!ft.Finish());
}

void AnalogDisplay() {
	do{
		cout << "EX : " << ft.GetAnalog(ftiEX) << " EY : " << ft.GetAnalog(ftiEY) << endl;
		ft.Pause(1111);
	} while(!ft.Finish());
}

void DriveForTime() {
	ft.SetMotor(ftiM3, ftiLeft);
	ft.Pause(3500);
	ft.SetMotor(ftiM3, ftiOff);
	cout << "Gone for 3.5 sec" << endl;
}

void DriveToEndSwitch1() {
	ft.SetMotor(ftiM3, ftiLeft);
	while(!ft.GetInput(ftiE5));
	ft.SetMotor(ftiM3, ftiOff);
	cout << "Switch E5 true" << endl;
}

void DriveToEndSwitch2() {
	ft.SetMotor(ftiM3, ftiLeft);
	ft.WaitForInput(ftiE5);
	ft.SetMotor(ftiM3, ftiOff);
	cout << "Switch E5 true" << endl;
}

void DriveForStepsC() {
	ft.SetMotor(ftiM3, ftiLeft);
	ft.WaitForChange(ftiE6, 12);
	ft.SetMotor(ftiM3, ftiOff);
}

void DriveForStepsD() {
	int ActPosition = 12;
	ft.SetMotor(ftiM3, ftiLeft);
	ActPosition = ft.WaitForPositionDown(ftiE6, ActPosition, 0, ftiE5);
	ft.SetMotor(ftiM3, ftiOff);
	cout << "ActPosition : " << ActPosition << endl;
}

void DriveForStepsU() {
	int ActPosition = 12;
	ft.SetMotor(ftiM3, ftiRight);
	ActPosition = ft.WaitForPositionUp(ftiE6, ActPosition, 24);
	ft.SetMotor(ftiM3, ftiOff);
	cout << "ActPosition : " << ActPosition << endl;
}

void DriveForStepsW() {
	ft.SetMotor(ftiM3, ftiLeft, ftiHalf, 12);
	ft.WaitForMotors(0, ftiM3);
	cout << "ActPosition += 12" << endl;
}

void DriveForStepsW34() {
	ft.SetMotor(ftiM3, ftiLeft,  ftiFull, 121);
	ft.SetMotor(ftiM4, ftiRight, ftiHalf, 64);
	do {
		cout << "Position M3 - M4 : " << ft.GetCounter(ftiE6) << " - " 
			<< ft.GetCounter(ftiE8) << endl;
	} while(ft.WaitForMotors(300, ftiM3, ftiM4) == ftiTime);
		cout << "Position M3 - M4 : " << ft.GetCounter(ftiE6) << " - " 
			<< ft.GetCounter(ftiE8) << "   --- Final ---" << endl;
}

void WaitForLightBarrierBroken() {
	const int mLight = 1, ePhoto = 1;
	ft.SetMotor(mLight, ftiOn);
	ft.Pause(555);
	ft.WaitForInput(ePhoto, false);
	cout << "LightBarrier M1 - E1 is broken" << endl;
}

void WaitForLightBarrierEnter() {
	const int mLight = 1, mFeeder = 3, ePhoto = 1;
	ft.SetMotor(mLight, ftiOn);
	ft.Pause(555);
	ft.SetMotor(mFeeder, ftiLeft);
	ft.WaitForLow(ePhoto);
	ft.SetMotor(mFeeder, ftiOff);
	cout << "LightBarrier M1 - E1 is entered" << endl;
}

void WaitForLightBarrierLeave() {
	const int mLight = 1, mFeeder = 3, ePhoto = 1;
	ft.SetMotor(mLight, ftiOn);
	ft.Pause(555);
	ft.SetMotor(mFeeder, ftiLeft);
	ft.WaitForHigh(ePhoto);
	ft.SetMotor(mFeeder, ftiOff);
	cout << "LightBarrier M1 - E1 is free" << endl;
}

void TrafficLights() {
	const int mGreen = 0x1, mYellow = 0x4, mRed = 0x10;
	while (!ft.Finish()) {
		ft.SetMotors(mGreen);
		ft.Pause(1000);
		ft.SetMotors(mYellow);
		ft.Pause(250);
		ft.SetMotors(mRed);
		ft.Pause(1000);
		ft.SetMotors(mRed + mYellow);
		ft.Pause(250);
	}
}

void TrafficLightsList() {
	const int mGreen = 0x1, mYellow = 0x4, mRed = 0x10;
	int Phase[] = {mGreen,  mGreen, mGreen, mGreen,
								 mYellow, mRed,   mRed,   mRed,   mRed,   mRed + mYellow};
	while(!ft.Finish()) {
		for(int i = 0; i <= 9; i++) {
			ft.SetMotors(Phase[i]);
			ft.Pause(250);
		}
	}
}

void RunningLights() {
	while(!ft.Finish()) {
		for(int Phase = 1; Phase < 0xFF; Phase <<= 2) {
			ft.SetMotors(Phase);
			ft.Pause(555);
		}
	}
}

void main() {
	cout << "--- FiFaTest gestartet ---" <<  endl;
	cout << "To end : ESC Key" << endl;

	try {
		ft.OpenInterface(2);

		RunningLights();

	}
	catch(CFishFaceException& fte) {
		cout << "Error " << fte.Nr() << " : " << fte.Text() << endl;
	}

	while(GetAsyncKeyState(VK_ESCAPE) == 0);
	ft.CloseInterface();
}