// -----------------------------------------------------------------------------------
//
// Fishing.CPP                                                 Ulrich Mller  11.08.04
//                                                             PCS1700        VC++ 6.0
// class CFishing for accessing the fischertechnik Interfaces
//
// 
// -----------------------------------------------------------------------------------

#include <windows.h>
#include "umFish30VC.h"

class CFishing {
private:
	int ft;
	int aSlave;
	int aPollInterval;
	int aAnalogScan;

public:
	CFishing(BOOL AnalogScan, BOOL Slave, int PollInterval) {
		aSlave        = Slave ? 1 : 0;
		aPollInterval = PollInterval;
		aAnalogScan   = AnalogScan ? 1 : 0;
	}

	void CloseInterface() {
		csCloseInterface(ft);
	}

	bool Finish() {
		if(GetAsyncKeyState(VK_ESCAPE) != 0) return true;
		return false;
	}

	bool GetInput(int InputNr) {
		return (csGetInput(ft, InputNr) == 0) ? false : true;
	}

	void OpenInterface(int PortNr) {
		if(PortNr < 0 || PortNr > 8) PortNr = 0;
		ft = csOpenInterfaceEx(PortNr, aAnalogScan, aSlave, aPollInterval, 0, 0);
		csSetMotors(ft, 0);
		aAnalogScan   = csGetAnalogScan(ft);
		aSlave        = csGetSlave(ft);
		aPollInterval = csGetPollInterval(ft);
	}

	void Pause(unsigned int mSek) {
		DWORD sZeit = GetTickCount();
		do {
			if(GetAsyncKeyState(VK_ESCAPE) != 0) return;
			Sleep(aPollInterval);
		} while (GetTickCount() - sZeit < mSek);
	}

	void SetMotor(int MotorNr, int Direction) {
		csSetMotor(ft, MotorNr, Direction);
	}

	void SetMotors(int MotorStatus) {
		csSetMotors(ft, MotorStatus);
	}
	void WaitForInput(int InputNr) {
		do {
			if(GetAsyncKeyState(VK_ESCAPE) != 0) return;
			Sleep(aPollInterval);
		} while(GetInput(InputNr) == false);
	}
};