// -------------------------------------------------------------------------------
//
// umFish30VC.CPP                                          Ulrich Mller  08.09.04
//                                                         PCS1700        VC++ 6.0
// Sample program VC++ (Console) for umFish30.DLL
// Lamps on  M1, M2, M3, Endswitch E1 and Photoresitor on EX (optional)
//
// ------------------------------------------------------------------------------

#include <windows.h>
#include <iostream.h>
#include "umFish30VC.h"

int ft;

void main()
{
	cout << "---- HelloFish started ----" << endl;
	cout << "umFish30 v" << csVersion() << endl;

	
	// --- Connection to the interface --------------------------------------------------
	ft = csOpenInterface(2, 1, 0, 0);    // -- COM2, AnalogScan, no Slave, Poll default 
	if(ft == ftiError)                   //          0 - 8 : LPT, COM1 - COM8
	{
		cout << "Interface Problem, exit" << endl;
		return;
	}
	cout << "OpenInterface succeeded" << endl;


	cout << "--- Loop for the three lamps on M1 to M3" << endl;
	for(int j=1; j<=4; j++) 
	{
		cout << "Round : " << j << endl;
		csSetMotors(ft, 0);              // --- all Motors off
		Sleep(300);                      // --- 0.3 sec Pause 
		for(int i=1; i<=3; i++) 
		{
			csSetMotor(ft, i, ftiOn);  // --- switch on Lamp on Mi
			Sleep (500);
		}
	}
  
	// --------------------------------- End -----------------------------------
  csSetMotors(ft, 0);              // --- all Motors off
	cout << "END : Input E1 = TRUE" << endl; 
	while(!csGetInput(ft, 1));       // --- Wait for E1 == true
	csCloseInterface(ft);            // --- Cut connection to the interface
}

