// -----------------------------------------------------------------------------------
//
// umFish30VC.h                                                Ulrich Mller   13.5.02
//                                                             PCS1700        VC++ 6.0
//
// Basic function for the fischertechnik interfaces (serial, parallel)
//     based on umFish.DLL (includes WinRT for using the parallel port)
// 
// -----------------------------------------------------------------------------------


typedef struct {
  HANDLE hCom;                 // --- PortHandle / Openflag ( = 0)
  DWORD PortID;                //     IO-Adresse bei LPT
  DWORD LPTDelay;              //     LPT Verzgerungsfaktor
  DWORD LPTAnalog;             //     LPT Analogfaktor 
  DWORD ECount;                //     Anzahl E-Eingnge (8/16)
  DWORD FID;                   // --- MultiMediaTimer Handle
  DWORD PollInterval;          //     Pollinterval des MM-Timers
  DWORD AnalogScan;            //     Pollen auch der Analogeingnge (0/1)
  DWORD OutputStatus;          // --- Status der M-Ausgnge     (00 | 01 | 10)
  DWORD MotorStatus;           //     SollStatus der M-Ausgnge (00 | 01 | 10)
  DWORD SpeedStatus;           //     Den M-Ausgngen zugeordnete Geschwindigkeit (0-15)
  DWORD ModeStatus;            //     Den M-Ausgngen zug. Betriebsstatus (0-15)
  DWORD intern;
  DWORD InputStatus;           //     Status der E-Eingnge
  DWORD Analogs[2];            //     Werte der A-Eingnge
  DWORD Counters[16];          //     Impulszhler an den E-Eingngen
} ftiDCB;

DWORD __stdcall umOpenInterface(ftiDCB &Interface, LPCSTR ComName);
DWORD __stdcall umCloseInterface(ftiDCB &Interface);
DWORD __stdcall umGetVersion();
DWORD __stdcall umGetAnalogDirect(ftiDCB &Interface, DWORD AnalogNr);
BOOL  __stdcall umGetInput(ftiDCB &Interface, DWORD InputNr);
DWORD __stdcall umSetLamp(ftiDCB &Interface, DWORD LampNr, DWORD OnOff);
DWORD __stdcall umSetMotor(ftiDCB &Interface, DWORD MotorNr, DWORD Direction);
DWORD __stdcall umSetMotorEx(ftiDCB &Interface, DWORD MotorNr, DWORD Direction, DWORD Speed);
DWORD __stdcall umSetMotors(ftiDCB &Interface, DWORD MotorStatus);
DWORD __stdcall umSetMotorsEx(ftiDCB &Interface, DWORD MotorStatus, DWORD SpeedStatus);
DWORD __stdcall umRobMotors(ftiDCB &Interface, DWORD MotorStatus, DWORD SpeedStatus,
							DWORD ModeStatus);
DWORD __stdcall umRobMotor(ftiDCB &Interface, DWORD MotorNr, DWORD Direction, 
						   DWORD Speed, DWORD ICount);

int   __stdcall csOpenInterface(int PortNr, int AnalogScan, int Slave, int PollInterface);
int   __stdcall csOpenInterfaceEx(int PortNr, int AnalogScan, int Slave, int PollInterface,
								  int LPTAnalog, int LPTDelay);
int   __stdcall csCloseInterface(int iHandle);
int   __stdcall csVersion();
int   __stdcall csGetAnalogScan(int iHandle);
int   __stdcall csGetLPTAnalog(int iHandle);
int   __stdcall csGetLPTDelay(int iHandle);
int   __stdcall csGetSlave(int iHandle);
int   __stdcall csGetPollInterval(int iHandle);
int   __stdcall csGetAnalogDirect(int iHandle, int AnalogNr);
int   __stdcall csGetInput(int iHandle, int InputNr);
int   __stdcall csGetInputs(int iHandle);
int   __stdcall csGetAnalog(int iHandle, int AnalogNr);
int   __stdcall csGetAnalogDirect(int iHandle, int AnalogNr);
int   __stdcall csSetMotor(int iHandle, int MotorNr, int Direction);
int   __stdcall csSetMotorEx(int iHandle, int MotorNr, int Direction, int Speed);
int   __stdcall csGetModeStatus(int iHandle, int MotorNr);
void  __stdcall csSetModeStatus(int iHandle, int MotorNr, int Value);
int   __stdcall csGetMotors(int iHandle);
int   __stdcall csSetMotors(int iHandle, int MotorStatus);
int   __stdcall csSetMotorsEx(int iHandle, int MotorStatus, int SpeedStatus);
int   __stdcall csSetLamp(int iHandle, int LampNr, int OnOff);
int   __stdcall csRobMotor(int iHandle, int MotorNr, int Direction, int Speed, int ICount);
int   __stdcall csRobMotors(int iHandle, int MotorStatus, int SpeedStatus, int ModeStatus);
int   __stdcall csGetCounter(int iHandle, int CounterNr);
void  __stdcall csSetCounter(int iHandle, int CounterNr, int Value);
void  __stdcall csClearCounters(int iHandle);

DWORD __stdcall StartDriver();
DWORD __stdcall StopDriver();

const DWORD ftiOff    = 0;
const DWORD ftiOn    = 1;
const DWORD ftiLeft  = 1;
const DWORD ftiRight = 2;

const DWORD ftiError = 0x0001FFFF;
